blob: 62e1e02126e61d5cde4945c9d7f922153ea6f90e [file] [log] [blame]
Sam Ravnborgae215b12006-01-08 18:39:44 +01001#!/bin/sh
2# Check ncurses compatibility
3
4# What library to link
5ldflags()
6{
Mike Frysinger03c95872007-05-17 15:06:31 -04007 for ext in so a dylib ; do
8 for lib in ncursesw ncurses curses ; do
9 $cc -print-file-name=lib${lib}.${ext} | grep -q /
10 if [ $? -eq 0 ]; then
11 echo "-l${lib}"
12 exit
13 fi
14 done
15 done
Sam Ravnborg60f33b82006-01-15 15:28:35 +010016 exit 1
Sam Ravnborgae215b12006-01-08 18:39:44 +010017}
18
19# Where is ncurses.h?
20ccflags()
21{
22 if [ -f /usr/include/ncurses/ncurses.h ]; then
23 echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
24 elif [ -f /usr/include/ncurses/curses.h ]; then
25 echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"'
26 elif [ -f /usr/include/ncurses.h ]; then
27 echo '-DCURSES_LOC="<ncurses.h>"'
28 else
29 echo '-DCURSES_LOC="<curses.h>"'
30 fi
31}
32
Sam Ravnborg3835f822006-01-21 12:03:09 +010033# Temp file, try to clean up after us
34tmp=.lxdialog.tmp
35trap "rm -f $tmp" 0 1 2 3 15
36
Sam Ravnborgae215b12006-01-08 18:39:44 +010037# Check if we can link to ncurses
38check() {
Sam Ravnborg6e588f62007-12-09 20:11:15 +010039 echo -e " #include CURSES_LOC \n main() {}" |
40 $cc -xc - -o $tmp 2> /dev/null
Sam Ravnborgae215b12006-01-08 18:39:44 +010041 if [ $? != 0 ]; then
Sam Ravnborg6e588f62007-12-09 20:11:15 +010042 echo " *** Unable to find the ncurses libraries or the" 1>&2
43 echo " *** required header files." 1>&2
44 echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
45 echo " *** " 1>&2
46 echo " *** Install ncurses (ncurses-devel) and try again." 1>&2
47 echo " *** " 1>&2
48 exit 1
Sam Ravnborgae215b12006-01-08 18:39:44 +010049 fi
50}
51
52usage() {
53 printf "Usage: $0 [-check compiler options|-header|-library]\n"
54}
55
Mike Frysingere99c3432007-05-23 21:37:45 -040056if [ $# -eq 0 ]; then
Sam Ravnborgae215b12006-01-08 18:39:44 +010057 usage
58 exit 1
59fi
60
Sam Ravnborg3835f822006-01-21 12:03:09 +010061cc=""
Sam Ravnborgae215b12006-01-08 18:39:44 +010062case "$1" in
63 "-check")
64 shift
Sam Ravnborg60f33b82006-01-15 15:28:35 +010065 cc="$@"
Sam Ravnborgae215b12006-01-08 18:39:44 +010066 check
67 ;;
68 "-ccflags")
69 ccflags
70 ;;
71 "-ldflags")
Sam Ravnborg60f33b82006-01-15 15:28:35 +010072 shift
73 cc="$@"
Sam Ravnborgae215b12006-01-08 18:39:44 +010074 ldflags
75 ;;
76 "*")
77 usage
78 exit 1
79 ;;
80esac